diff -uwr source/scripts/z_reconnaissance.cpp 4.0/source/scripts/z_reconnaissance.cpp
--- source/scripts/z_reconnaissance.cpp	2011-05-26 09:34:42.000000000 +0800
+++ 4.0/source/scripts/z_reconnaissance.cpp	2011-10-11 23:13:45.326171800 +0800
@@ -1,14 +1,12 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "General.h"
diff -uwr source/scripts/z_reconnaissance.h 4.0/source/scripts/z_reconnaissance.h
--- source/scripts/z_reconnaissance.h	2011-05-24 19:05:46.000000000 +0800
+++ 4.0/source/scripts/z_reconnaissance.h	2011-10-14 22:27:32.198242100 +0800
@@ -1,16 +1,15 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class z_rec_CheckpointControl : public ScriptImpClass {
 	void Created(GameObject *obj);
diff -uwr source/scripts/z_ship.cpp 4.0/source/scripts/z_ship.cpp
--- source/scripts/z_ship.cpp	2011-05-14 22:28:34.000000000 +0800
+++ 4.0/source/scripts/z_ship.cpp	2011-10-11 23:13:43.605468700 +0800
@@ -1,14 +1,12 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "General.h"
diff -uwr source/scripts/z_ship.h 4.0/source/scripts/z_ship.h
--- source/scripts/z_ship.h	2011-05-07 07:43:20.000000000 +0800
+++ 4.0/source/scripts/z_ship.h	2011-10-14 22:27:31.944335900 +0800
@@ -1,16 +1,15 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class z_Ship_TorpedoRack : public ScriptImpClass {
 	void Created(GameObject *obj);
diff -uwr source/scripts/z_siege.cpp 4.0/source/scripts/z_siege.cpp
--- source/scripts/z_siege.cpp	2010-10-15 07:19:22.000000000 +0800
+++ 4.0/source/scripts/z_siege.cpp	2011-10-11 23:13:42.152343700 +0800
@@ -1,14 +1,12 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2010 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "General.h"
diff -uwr source/scripts/z_siege.h 4.0/source/scripts/z_siege.h
--- source/scripts/z_siege.h	2010-10-15 07:19:22.000000000 +0800
+++ 4.0/source/scripts/z_siege.h	2011-10-14 22:27:31.995117100 +0800
@@ -1,16 +1,15 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2010 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 
 class z_Siege_Mission_Start : public ScriptImpClass {
diff -uwr source/scripts/z_uberaow.cpp 4.0/source/scripts/z_uberaow.cpp
--- source/scripts/z_uberaow.cpp	2011-08-20 10:11:46.000000000 +0800
+++ 4.0/source/scripts/z_uberaow.cpp	2011-10-11 23:13:40.107421800 +0800
@@ -1,14 +1,12 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "General.h"
diff -uwr source/scripts/z_uberaow.h 4.0/source/scripts/z_uberaow.h
--- source/scripts/z_uberaow.h	2011-08-20 10:11:46.000000000 +0800
+++ 4.0/source/scripts/z_uberaow.h	2011-10-14 22:27:32.074218700 +0800
@@ -1,16 +1,15 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class z_Player : public ScriptImpClass {
 	void Custom(GameObject *obj, int message, int param, GameObject *sender);
diff -uwr source/scripts/z_zones.cpp 4.0/source/scripts/z_zones.cpp
--- source/scripts/z_zones.cpp	2011-05-04 12:50:52.000000000 +0800
+++ 4.0/source/scripts/z_zones.cpp	2011-10-11 23:14:32.120117100 +0800
@@ -1,14 +1,12 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
 #include "General.h"
diff -uwr source/scripts/z_zones.h 4.0/source/scripts/z_zones.h
--- source/scripts/z_zones.h	2011-04-28 07:18:42.000000000 +0800
+++ 4.0/source/scripts/z_zones.h	2011-10-14 22:27:32.053710900 +0800
@@ -1,16 +1,15 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - mp-gaming.com
-	Copyright 2011 zunnie
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
-	under the terms of the GNU General Public License as published by the Free
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
 	Software Foundation; either version 2, or (at your option) any later
 	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
-	with any closed source module that does not contain code covered by this licence.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 
 class z_Sell_Zone : public JFW_Key_Hook_Base {
 	int ID;
diff -uwr source/scripts_VC2010.sln 4.0/source/scripts_VC2010.sln
--- source/scripts_VC2010.sln	2011-08-09 11:07:26.000000000 +0800
+++ 4.0/source/scripts_VC2010.sln	2011-10-14 19:52:39.833007800 +0800
@@ -102,6 +102,8 @@
 		{9B549C98-0BF4-4092-AE2A-AD7F780F8405} = {9B549C98-0BF4-4092-AE2A-AD7F780F8405}
 	EndProjectSection
 EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "makemix", "makemix\makemix.vcxproj", "{51D89B89-4A13-4263-8148-A10D78DC9416}"
+EndProject
 Global
 	GlobalSection(SubversionScc) = preSolution
 		Svn-Managed = True
@@ -234,6 +236,14 @@
 		{6BA46F59-EAAB-4E4C-90AD-725469504AA5}.Release SSGM|Win32.ActiveCfg = Release SSGM|Win32
 		{6BA46F59-EAAB-4E4C-90AD-725469504AA5}.Release SSGM|Win32.Build.0 = Release SSGM|Win32
 		{6BA46F59-EAAB-4E4C-90AD-725469504AA5}.Release|Win32.ActiveCfg = Release SSGM|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Debug SSGM|Win32.ActiveCfg = Debug|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Debug SSGM|Win32.Build.0 = Debug|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Debug|Win32.ActiveCfg = Debug|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Debug|Win32.Build.0 = Debug|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Release SSGM|Win32.ActiveCfg = Release|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Release SSGM|Win32.Build.0 = Release|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Release|Win32.ActiveCfg = Release|Win32
+		{51D89B89-4A13-4263-8148-A10D78DC9416}.Release|Win32.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
diff -uwr source/swap/General.cpp 4.0/source/swap/General.cpp
--- source/swap/General.cpp	2011-04-29 19:21:12.000000000 +0800
+++ 4.0/source/swap/General.cpp	2011-10-11 23:02:55.377929600 +0800
@@ -1 +1,12 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
diff -uwr source/swap/General.h 4.0/source/swap/General.h
--- source/swap/General.h	2011-04-29 19:21:12.000000000 +0800
+++ 4.0/source/swap/General.h	2011-10-11 23:02:53.966796800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef SWAP_INCLUDE__GENERAL_H
 #define SWAP_INCLUDE__GENERAL_H
 
diff -uwr source/swap/Swap.cpp 4.0/source/swap/Swap.cpp
--- source/swap/Swap.cpp	2011-04-30 09:22:40.000000000 +0800
+++ 4.0/source/swap/Swap.cpp	2011-10-13 07:20:03.158203100 +0800
@@ -1,12 +1,67 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "Swap.h"
 #include "gmgame.h"
 #include "Iterator.h"
 
+#define GDI 1
+#define NOD 0
+#define GREEN "104,234,40"
 
 bool IsRTC = false;
 int idrtc = 0;
 
+void PPage(int ID, const char* rgb_colour, const char *Format, ...)
+{
+	if(ID < 1 || ID > 128)
+	{
+		return;
+	}
+
+	if (!Get_GameObj(ID))
+	{
+		return;
+	}
+
+	char buffer[256];
+	va_list va;
+	_crt_va_start(va, Format);
+	vsnprintf(buffer, 256, Format, va);
+	va_end(va);
+
+	float Version = Get_Client_Version(ID);
+
+	if(Version < 2.9)
+	{
+		Console("ppage %d %s",ID, buffer);
+                return;
+	}
+	else
+	{
+		Console("cmsgp %d %s %s", ID, rgb_colour, buffer);
+	}
+}
+
+void Console(const char *Format, ...)
+{
+	char buffer[256];
+	va_list va;
+	_crt_va_start(va, Format);
+	vsnprintf(buffer, 256, Format, va);
+	va_end(va);
+	Console_Input(buffer);
+}
+
 DynamicVectorClass<StringClass> SwappedPlayers;  
 
 bool SwapCheck(int ID) 
@@ -41,6 +96,7 @@
 public:
 	int SwapGameTimeLimit;
 	int SwapExpireLimit;
+	StringClass PPageColour;
 	DynamicVectorClass<StringClass> PresetNames;
 
 	SWAP()
@@ -66,14 +122,12 @@
 		{
 			if ((wcsistr(Message,L"!swap") == Message) || (wcsistr(Message,L"!rtc") == Message))
 			{ 
-				StringClass tmp;
 				for(int i = 0; i < PresetNames.Count(); i++)
 				{
 					if((strcmp(Commands->Get_Preset_Name(Get_GameObj(PlayerID)),PresetNames[i]))== 0)
 					{
-						tmp.Format("ppage %d Unfortunately this preset type has been disallowed from using the command.",PlayerID);
-						Console_Input(tmp);
-						return true;
+						PPage(PlayerID, PPageColour, "Unfortunately this preset type has been disallowed from using the command.");
+						return false;
 					}
 				}
 				if (SwapCheck(PlayerID) == false) 
@@ -82,10 +136,9 @@
 				}
 				else 
 				{
-					tmp.Format("ppage %d You have already swapped once. There is a limit of one successful swap per map, per player.",PlayerID);
-					Console_Input(tmp);
+					PPage(PlayerID, PPageColour, "You have already swapped once. There is a limit of one successful swap per map, per player.");
 				}
-				return true;
+				return false;
 			}
 		}
 		return true;
@@ -93,13 +146,9 @@
 
 	virtual void OnLoadGlobalINISettings(INIClass *SSGMIni) 
 	{
-		//StringClass Setting;
 		SwapGameTimeLimit = SSGMIni->Get_Int("Swap", "SwapGameTimeLimit", 300);
-		//Setting.Format("SwapGameTimeLimit = %i\n", SwapGameTimeLimit);
-		//Console_Output(Setting);
 		SwapExpireLimit = SSGMIni->Get_Int("Swap", "SwapExpireLimit", 60);
-		//Setting.Format("SwapExpireLimit = %i\n", SwapExpireLimit);
-		//Console_Output(Setting);
+		SSGMIni->Get_String(PPageColour,"Swap", "PPageColour", GREEN);
 		int count = SSGMIni->Entry_Count("ListOfPresets");
 		for (int i = 0; i < count; i++)
 		{
@@ -108,17 +157,6 @@
 			SSGMIni->Get_String(entry_string, "ListOfPresets", entry_name, "42");
 			PresetNames.Add(entry_string.Peek_Buffer());
 		}
-		/*
-		StringClass Msg;
-		Msg.Format("ListOfPresets: \n");
-		Console_Output(Msg);
-		for(unsigned int i = 0; i < PresetNames.size(); i++)
-		{
-			Msg.Format("%s ", PresetNames[i].c_str());
-			Console_Output(Msg);
-		}
-		*/
-
 	}
 
 	virtual void OnLoadLevel() 
@@ -141,8 +179,30 @@
 
 	if (The_Game()->Get_Game_Duration_S() < (unsigned)swap.SwapGameTimeLimit)
 	{
-		int GDIPlayers = Get_Team_Player_Count(0);
-		int NodPlayers = Get_Team_Player_Count(1);
+		int NodPlayers = Get_Team_Player_Count(NOD);
+		int GDIPlayers = Get_Team_Player_Count(GDI);
+
+		if (abs(GDIPlayers-NodPlayers) > 1)
+		{
+			int Team = Get_Team(PlayerID);
+			StringClass Msg, Msg2;
+			const char *str = Get_Team_Name(Get_Team(idrtc) ? GDI : NOD);
+			Msg2.Format("msg %s has joined forces with the %s team.",Get_Player_Name(Get_GameObj(PlayerID)),str);
+			if ((GDIPlayers > NodPlayers) && (Team == GDI))
+			{
+				Msg.Format("team2 %d %i",PlayerID, NOD);
+				Console_Input(Msg);
+				Console_Input(Msg2);
+				return;
+			}
+			else if ((NodPlayers > GDIPlayers) && (Team == NOD))
+			{
+				Msg.Format("team2 %d %i",PlayerID, GDI);
+				Console_Input(Msg);
+				Console_Input(Msg2);
+				return;
+			}
+		}
 		if (!IsRTC) 
 		{
 			if (GDIPlayers > 0 && NodPlayers > 0)
@@ -154,7 +214,7 @@
 				Commands->Attach_Script(rtccontroller,"RTC_timer","");
 				const char *str = Get_Team_Name(0);
 				const char *str2 = Get_Team_Name(1);
-				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There is 1 minute remaining before this expires.",Get_Player_Name(Get_GameObj(PlayerID)),str,str2);
+				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There is %i seconds remaining before this expires.", Get_Player_Name(Get_GameObj(PlayerID)), str, str2, swap.SwapExpireLimit);
 				Console_Input(Msg);
 				delete[] str;
 				delete[] str2;
@@ -162,8 +222,7 @@
 			}
 			else 
 			{
-				Msg.Format("ppage %d Unfortunately there are not enough people in the server for you to swap teams",PlayerID);
-				Console_Input(Msg);
+				PPage(PlayerID, swap.PPageColour, "Unfortunately there are not enough people in the server for you to swap teams.");
 			}
 		}
 		else if (IsRTC)
@@ -204,16 +263,14 @@
 
 				else if (Get_Team(PlayerID) == Get_Team(idrtc))
 				{
-					Msg.Format("ppage %d You're on the same team, you cannot swap with %s.",PlayerID,Get_Player_Name_By_ID(idrtc));
-					Console_Input(Msg);
+					PPage(PlayerID, swap.PPageColour, "You're on the same team, you cannot swap with %s.", Get_Player_Name_By_ID(idrtc));
 				}
 			}
 		}
 	}
 	else 
 	{
-		Msg.Format("ppage %d Unfortunately five minutes has passed into the game. No swapping is allowed after five minutes of map time.",PlayerID);
-		Console_Input(Msg);
+		PPage(PlayerID, swap.PPageColour, "Unfortunately %i seconds has passed into the game. No swapping is allowed after %i seconds of map time.", The_Game()->Get_Game_Duration_S(), swap.SwapGameTimeLimit);
 	}
 }
 
@@ -238,11 +295,12 @@
 		}
 		else
 		{
+			const char *str = Get_Team_Name(Get_Team(idrtc) ? GDI : NOD);
 			StringClass Msg;
-			Msg.Format("msg %s's request to change teams has expired.",Get_Player_Name_By_ID(idrtc));
-			Console_Input(Msg);
-			Msg.Format("ppage %d Your request to change teams has timed out.",idrtc);
+			Msg.Format("msg %s's request to change to team %s has expired.",Get_Player_Name_By_ID(idrtc), str);
 			Console_Input(Msg);
+			PPage(idrtc, swap.PPageColour, "Your request to change to team %s has timed out.", str);
+			delete[] str;
 			idrtc = 0;
 			Commands->Destroy_Object(obj);
 			Destroy_Script();
@@ -250,6 +308,7 @@
 	}
 }
 
+ScriptRegistrant<RTC_timer> RTC_timer_Registrant("RTC_timer","");
 
 extern "C" __declspec(dllexport) Plugin* Plugin_Init()
 {
diff -uwr source/swap/Swap.h 4.0/source/swap/Swap.h
--- source/swap/Swap.h	2011-04-29 19:21:12.000000000 +0800
+++ 4.0/source/swap/Swap.h	2011-10-13 07:19:59.104492100 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #pragma once
 
 #include "gmplugin.h"
@@ -15,3 +26,5 @@
 void SwapClearPlayers();
 
 void RequestTeamChange(int PlayerID);
+void Console(const char *Format, ...);
+void  __cdecl PPage(int ID, const char* rgb_colour, const char *Format, ...);
diff -uwr source/tdbedit/Search.cpp 4.0/source/tdbedit/Search.cpp
--- source/tdbedit/Search.cpp	2011-04-25 15:58:38.000000000 +0800
+++ 4.0/source/tdbedit/Search.cpp	2011-10-11 23:02:47.273437500 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 #include <windows.h>
 #include <stdlib.h>
diff -uwr source/tdbedit/Search.h 4.0/source/tdbedit/Search.h
--- source/tdbedit/Search.h	2009-11-20 16:44:28.000000000 +0800
+++ 4.0/source/tdbedit/Search.h	2011-10-11 23:02:45.808593700 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef _SEARCH_H_
 #define _SEARCH_H_
 
diff -uwr source/tdbedit/general.cpp 4.0/source/tdbedit/general.cpp
--- source/tdbedit/general.cpp	2009-04-12 11:54:02.000000000 +0800
+++ 4.0/source/tdbedit/general.cpp	2011-10-11 23:02:50.010742100 +0800
@@ -1 +1,12 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
diff -uwr source/tdbedit/general.h 4.0/source/tdbedit/general.h
--- source/tdbedit/general.h	2011-03-08 09:59:54.000000000 +0800
+++ 4.0/source/tdbedit/general.h	2011-10-11 23:02:48.638671800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TDBEDIT_INCLUDE__GENERAL_H
 #define TDBEDIT_INCLUDE__GENERAL_H
 #include "Defines.h"
diff -uwr source/tdbedit/tdbedit.cpp 4.0/source/tdbedit/tdbedit.cpp
--- source/tdbedit/tdbedit.cpp	2011-04-25 15:54:54.000000000 +0800
+++ 4.0/source/tdbedit/tdbedit.cpp	2011-10-11 23:02:44.485351500 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 #include <windows.h>
 #include <stdio.h>
diff -uwr source/tdbedit/tdbedit.h 4.0/source/tdbedit/tdbedit.h
--- source/tdbedit/tdbedit.h	2009-11-19 18:48:10.000000000 +0800
+++ 4.0/source/tdbedit/tdbedit.h	2011-10-11 23:02:43.047851500 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef _MAIN_H_
 #define _MAIN_H_
 #include <windows.h>
diff -uwr source/tdbedit/tdbedit.vcxproj 4.0/source/tdbedit/tdbedit.vcxproj
--- source/tdbedit/tdbedit.vcxproj	2011-04-25 16:23:52.000000000 +0800
+++ 4.0/source/tdbedit/tdbedit.vcxproj	2011-10-19 11:34:17.688476500 +0800
@@ -123,7 +123,7 @@
       <MinimalRebuild>false</MinimalRebuild>
       <ExceptionHandling>
       </ExceptionHandling>
-      <RuntimeLibrary>MultiThreadedDebug</RuntimeLibrary>
+      <RuntimeLibrary>MultiThreadedDLL</RuntimeLibrary>
       <BufferSecurityCheck>false</BufferSecurityCheck>
       <FunctionLevelLinking>true</FunctionLevelLinking>
       <EnableEnhancedInstructionSet>NotSet</EnableEnhancedInstructionSet>
